<?php

namespace app\controllers;

use app\core\AcutrackAPI;
use DB;
use Rakit\Validation\Validator;
use app\core\Controller;
use app\core\Request;
use app\core\RetrieveData;
use app\models\RegisterModel;
use Josantonius\Session\Facades\Session;
class AuthController extends Controller
{
    public RetrieveData $retrieve;
    public AcutrackAPI $acutrack;
    public function __construct()
    {
        $this->retrieve = new RetrieveData();
        $this->acutrack = new AcutrackAPI();
        
    }

    public function login(Request $request)
    {
        
        if ($this->logged_in()) {
            header( "Location: ".admin_url.'dashboard' );exit;   
        }
        $params = ['form_error' => [],'login_error'=>''];
        if ($request->isPost()) {
            $process=$this->handleLoginProcess($request);
            if($process['status']=='0'){
                $params['login_error']=$process['message'];
            }
            elseif($process['status']=='1'){
                
                header( "Location: ".admin_url.'dashboard' );exit; 
            }
            elseif($process['status']=='2'){
                $params['form_error']=$process['message'];
            }
        }

        $view = ['front/login_view'];
        return $this->render($view, $params);
    }
    function logged_in() {
        return isset($_SESSION['user']['user_id']);
    }
    public function handleLoginProcess($request){
        $validator = new Validator();
        $validation = $validator->make($_POST, [
            'user_name'   => 'required',
            'password'    => 'required',
        ]);

        $validation->validate();
        if ($validation->fails()) {
            $errors = $validation->errors();
            return ['status'=>2,'message'=>$errors->firstOfAll()];
        } else {
            $data=$request->getBody();
            $sql='SELECT * FROM wb_monitor_user WHERE user_name="'.$data['user_name'].'" AND user_password= "'.md5($data['password']).'"';
            $result = DB::query($sql);
            if(!empty($result)){
                $result=reset($result);
                $zone_client_list=$this->retrieve->get_zone_funnel_client();
                $client_list=$this->acutrack->get_acutrack_client_list();
                if($client_list['status']==1){
                    $client_list=array_replace_recursive(
                        array_combine(array_column($zone_client_list, "companyId"), $zone_client_list),
                        array_combine(array_column($client_list['message'], "companyId"), $client_list['message'])
                    ); 
                } 

                $gateway_list=$this->acutrack->get_acutrack_gateway_list();
                $page['client_list']=$client_list;
                $page['gateway_list']=($gateway_list['status']==1)?$gateway_list['message']:[];
                
                Session::set('user', $result);
                Session::set('page', $page);
                if (in_array(strtolower($result['user_role']), ['supe-admin', 'admin'])){
                    Session::set('page_name', 'admin');
                }else{
                    Session::set('page_name', 'monitor');
                }
                return ['status'=>1,'message'=>'Logged in Successfully'];
            }else{
                return ['status'=>0,'message'=>'The User Name or Password Mismatched!'];
            }
        }

        
    }
    public function logout(){
        Session::clear();
        header( "Location: ".site_url );exit;

    }
    public function register(Request $request)
    {
        if ($request->isPost()) {
            $registerModel = new RegisterModel();
            return 'post';
        }
        $this->setLayout('auth');
        return $this->render('register');
    } 

    
}
