<?php

namespace app\controllers;

use app\core\Application;
use app\core\Controller;
use app\core\Request;
use app\core\Response;
use app\models\CommonModel;
use Josantonius\Session\Facades\Session;

class SiteController extends Controller{
    public Response $response;
   
    public function __construct(){
        $this->response = new Response();
        
    }
    public  function home(){
        header( "Location: ".site_url.'login' );
    }
    public  function contact(){
        return $this->render('contact');
    }
    public static function handleContact(Request $request){
        $body=$request->getBody();
        echo '<pre>';
        print_r($body);
        die;
        return 'Handling Submitted data'; 
    }
    public function post_ajax_control(Request $request){
        $this->login_check();
        $body=$request->getBody();

        if (isset($body['request']) && $body['request'] == 'update_user_activity') {
            $user_activity_data = [
                'activity_name'         => $body['name'],
                'activity_page_url'     => $body['page_url'],
                'activity_client_id'    => $body['client_id'],
                'activity_api_id'       => $body['api_id'],
                'activity_user_id'      => $_SESSION['user']['user_id'],
                'activity_desc'         => $body['desc'] ?? '',
            ];

            $result =CommonModel::update_user_activity($user_activity_data);
            if ($result) {
                $report = ['status' => 1, 'message' => 'Added Successfully'];
            } else {
                $report = ['status' => 0, 'message' => 'Something went wrong please check'];
            }
    
            echo json_encode($report);exit;
        }
    }

    public function get_ajax_control(Request $request){
        
        $this->login_check();
        $body=$request->getBody();
        
        if(isset($body['request']) && $body['request']=='get_client_store_list' ){
            $client_id=$body['client_id'];
            $_SESSION['page']['page_client_id']=$client_id;
            $result= CommonModel::get_client_store_list($client_id);

            if(!empty($result)){
                $report=['status'=>1,'message'=>$result];
                echo json_encode($report);exit;
            }else{

                $report=['status'=>0,'message'=>'There is no data'];
                echo json_encode($report);exit;
            }
            
        }

        $report=['status'=>0,'message'=>'Invalid Request'];
        echo json_encode($report);exit;   
    }
    

    

    public function login_check(){
         if(!isset($_SESSION['user']['user_id'])){
            $this->response->setStatusCode(408); 
            $report=['status'=>408,'message'=>'Session Time out'];;
            echo json_encode($report);exit;  
         }
     }

     
}