<?php

namespace app\controllers\admin;

use app\controllers\admin\LoginValidate;
use app\core\Controller;
use app\core\Request;
use app\core\ZoneFunnelAPI;
use app\models\CommonModel;
use Josantonius\Session\Facades\Session;

class AdminController extends Controller
{
    public LoginValidate $validate;
    public function __construct()
    {
        $validate = new LoginValidate();
    }
    public function index()
    {

        $params = [
            'title' => ' Dashboard - ZF ',
            'client_list' => Session::get('page')['client_list'],
            'page_client_id' => Session::get('page')['page_client_id'] ?? '',

        ];
        // echo '<pre>';
        // print_r(Session::all());
        // die;
        $view = [
            'admin/layout/admin_header_view',
            'admin/dashboard_view_new',
            'admin/layout/admin_footer_view'
        ];
        return $this->render($view, $params);
    }

    public function authorize(Request $request)
    {   
        $body = $request->getBody();

        if (isset($body['page']) && $body['page'] == 'testing_table') {
            $user_activity_data = [
                'activity_name'         => 'VIEW-SHOPWISE-TESTING-DATA',
                'activity_page_url'     => site_url . 'customer_api_list_in.php',
                'activity_client_id'    => $body['client_id'],
                'activity_api_id'       => $body['api_id'],
                'activity_user_id'      => $_SESSION['user']['user_id'],
            ];
            CommonModel::update_user_activity($user_activity_data);
            $zone_api = ZoneFunnelAPI::zone_auth_token();
         
            if($zone_api['status']==1){
                $filter_data['authtoken'] = $zone_api['access_token'];
                if (isset($body['shop_id'])) {
                    $filter_data['shop_id'] = $body['shop_id'];
                }
                $query = http_build_query($filter_data);
                $domain = live_url . 'testing_order?';

                $url = $domain . $query;;
                header("Location: " . $url);exit;
            }else{
            
                $url=admin_url.'error_page?msg='.$zone_api['message']??'';
                header("Location: " . $url);exit;
                
            }
            
            
        }

        if(isset($body['action']) && in_array($body['action'],['order_log','ship_log','email_log'])){
            

            if($_GET['action']==='order_log'){
                $body['action']='log';
                $activity_name='VIEWED-ORDER-LOG';
            }
            else if($_GET['action']==='ship_log'){
                $body['action']='ship';
                $activity_name='VIEWED-SHIPPING-LOG';
            }
            else if($body['action']==='email_log'){
                $_GET['action']='email_log';
                $activity_name='VIEWED-EMAIL-LOG';
            }

            $user_activity_data=[
                'activity_name'         => $activity_name ,
                'activity_page_url'     => site_url.'customer_api_list_in.php' ,
                'activity_client_id'    => $body['client_id'] ,
                'activity_api_id'       => $body['api_id'] ,
                'activity_user_id'      => $_SESSION['user']['user_id'] ,
            ];
            CommonModel::update_user_activity($user_activity_data);
            $zone_api = ZoneFunnelAPI::zone_auth_token();

            if($zone_api['status']==1){
                $filter_data['authtoken'] = $zone_api['access_token'];
               
                $filter_data=array_merge($body,$filter_data);
                $domain=authorize_url.'index_html_log_trigger.php?';
                $query=http_build_query($filter_data);
                $url=$domain.$query;
                header( "Location: ".$url ); exit;
            }else{
            
                $url=admin_url.'error_page?msg='.$zone_api['message']??'';
                header("Location: " . $url);exit;
                
            }

            
          
        }

    }

    public function error_page(Request $request){
        $body = $request->getBody();
        $params = [
            'title' => ' Error - ZF ',
            'message' => $body['msg']??''
        ];

        $view = [
            'admin/error_page',
        ];
        return $this->render($view,$params);
    }
    
}
