<?php
namespace app\core;

use DB;

class AcutrackAPI
{
    

    function get_zone_shipped_orders($params){
	
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => live_url . 'api/track_shipped_orders',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_SSL_VERIFYHOST => 0,//for ssl
            CURLOPT_SSL_VERIFYPEER => 0,//for ssl
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => json_encode($params),
            CURLOPT_HTTPHEADER => array(
                'Content-Type: application/json',
            ),
        ));
        $response = curl_exec($curl);
        if (curl_errno($curl)) {
            $error_msg = curl_error($curl);
            $report = ['status' => 0, 'message' => $error_msg];
        } else {
            $response_arr = json_decode($response, true);
            $report = ['status' => 1, 'message' => $response_arr];
        }
        curl_close($curl);
    
        return $report;
    }
    
    function get_shopify_location($store_url,$token){
        $curl = curl_init();
    
        curl_setopt_array($curl, array(
          CURLOPT_URL => $store_url,
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => '',
          CURLOPT_MAXREDIRS => 10,
          CURLOPT_TIMEOUT => 0,
          CURLOPT_SSL_VERIFYHOST => 0,//for ssl
          CURLOPT_SSL_VERIFYPEER => 0,//for ssl
          CURLOPT_FOLLOWLOCATION => true,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => 'GET',
          CURLOPT_HTTPHEADER => array(
            'X-Shopify-Access-Token: '.$token
          ),
        ));
        
        $response = curl_exec($curl);
        $response_arr = json_decode($response, true);
        if (curl_errno($curl)) {
            $error_msg = curl_error($curl);
            $report = ['status' => 0, 'message' => $error_msg];
        } else {
            $report = ['status' => 1, 'message' => $response_arr];
        }
        curl_close($curl);
    
        return $report;
    }
    
    
    
    function update_client_gatewaylist($token,$get_arr,$id){
        $query=http_build_query($get_arr);
        $url=acutrack_api_url.'Account/ClientGatewaysActions?'.$query;
         $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_SSL_VERIFYHOST => 0,//for ssl
            CURLOPT_SSL_VERIFYPEER => 0,//for ssl
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'PUT',
            CURLOPT_POSTFIELDS => '['.$id.']',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer '.$token,
                'Content-Type: application/json',
            ),
        ));
        $response = curl_exec($curl);
        $response_arr = json_decode($response, true);
        if (curl_errno($curl)) {
            $error_msg = curl_error($curl);
            $report = ['status' => 0, 'message' => $error_msg];
        } else {
            $report = ['status' => 1, 'message' => $response_arr];
        }
        curl_close($curl);
        return $report;
    }
    function create_client_gateway_fun($post_data,$token){
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => acutrack_api_url . 'Account/SetupOrUpdateClientGateway',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_SSL_VERIFYHOST => 0,//for ssl
            CURLOPT_SSL_VERIFYPEER => 0,//for ssl
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => json_encode($post_data),
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer '.$token,
                'Content-Type: application/json',
                
            ),
        ));
        $response = curl_exec($curl);
        $response_arr = json_decode($response, true);
        if (curl_errno($curl) || (!empty($response_arr) && isset($response_arr['status']) && $response_arr['status']==false)) {
            $error_msg = curl_error($curl);
            $report = ['status' => 0, 'message' => $error_msg];
        } else {
            $report = ['status' => 1, 'message' => $response_arr];
        }
        curl_close($curl);
    
        return $report;
    }
    function get_acutrack_auth_token()
    {
    
    
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => acutrack_api_url . 'Authentication/authenticate',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_SSL_VERIFYHOST => 0,//for ssl
            CURLOPT_SSL_VERIFYPEER => 0,//for ssl
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => '{
                    "userName": "ranguraj@acutrack.com",
                    "password": "123456",
                    "isPortal": true
                    }',
            CURLOPT_HTTPHEADER => array(
                'Content-Type: application/json',
            ),
        ));
    
        $response = curl_exec($curl);
        if (curl_errno($curl)) {
            $error_msg = curl_error($curl);
            $report = ['status' => 0, 'message' => $error_msg];
        } else {
            $response_arr = json_decode($response, true);
            $report = ['status' => 1, 'token' => $response_arr['token']];
        }
        curl_close($curl);
    
        return $report;
    }
    
    function get_acutrack_client_store_list($client_id){
        $token=$this->get_acutrack_auth_token();
        $token=$token['token'];
        $curl = curl_init();
    
        curl_setopt_array($curl, array(
            CURLOPT_URL => acutrack_api_url.'V1/Order/GateWayStoreNames/'.$client_id,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_SSL_VERIFYHOST => 0,//for ssl
            CURLOPT_SSL_VERIFYPEER => 0,//for ssl
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer '.$token),
        ));
    
        $response = curl_exec($curl);
        $response_arr = json_decode($response, true);
        if (curl_errno($curl) ){
            $error_msg = curl_error($curl);
            $report = ['status' => 0, 'message' => $error_msg];
        } else {
            $report = ['status' => 1, 'message' => $response_arr];
        }
        curl_close($curl);
    
        return $report;
    }
    
    function get_acutrack_gateway_list(){
        $token=$this->get_acutrack_auth_token();
        $token=$token['token'];
        $curl = curl_init();
    
        curl_setopt_array($curl, array(
            CURLOPT_URL => acutrack_api_url.'/Account/Gateways',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_SSL_VERIFYHOST => 0,//for ssl
            CURLOPT_SSL_VERIFYPEER => 0,//for ssl
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer '.$token),
        ));
    
        $response = curl_exec($curl);
        $response_arr = json_decode($response, true);
        if (curl_errno($curl) ){
            $error_msg = curl_error($curl);
            $report = ['status' => 0, 'message' => $error_msg];
        } else {
            $report = ['status' => 1, 'message' => $response_arr];
        }
        curl_close($curl);
    
        return $report;
    }
    
    function get_acutrack_client_list(){
        $token=$this->get_acutrack_auth_token();
        // echo '<pre>';
        // print_r($token);
        // die;
        $token=$token['token'];
        $curl = curl_init();
    
        curl_setopt_array($curl, array(
            CURLOPT_URL => acutrack_api_url.'/Account/ListClients/0/1000/4',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_SSL_VERIFYHOST => 0,//for ssl
            CURLOPT_SSL_VERIFYPEER => 0,//for ssl
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer '.$token),
        ));
    
        $response = curl_exec($curl);
        $response_arr = json_decode($response, true);
        if (curl_errno($curl) ){
            $error_msg = curl_error($curl);
            $report = ['status' => 0, 'message' => $error_msg];
        } else {
            $report = ['status' => 1, 'message' => $response_arr];
        }
        curl_close($curl);
    
        return $report;
    }
    
    function get_acutrack_shipped_orders($client_id,$params,$limit=10000){
        $token=$this->get_acutrack_auth_token();
        $token=$token['token'];
        $url=acutrack_api_url.'V1/Order/ListOrders/0/'.$limit.'/'.$client_id;
        $url.='?'.http_build_query($params);
    
        $curl = curl_init();
    
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_SSL_VERIFYHOST => 0,//for ssl
            CURLOPT_SSL_VERIFYPEER => 0,//for ssl
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer '.$token),
        ));
    
        $response = curl_exec($curl);
        $response_arr = json_decode($response, true);
        if (curl_errno($curl) || (!empty($response_arr) && isset($response_arr['status']) && $response_arr['status']==false)) {
            $error_msg = curl_error($curl);
            $report = ['status' => 0, 'message' => $error_msg];
        } else {
            $report = ['status' => 1, 'message' => $response_arr];
        }
        curl_close($curl);
    
        return $report;
    
    }
    
    
    function get_acutrack_shipped_orders_response($token,$client_id,$id){
    
        $url=acutrack_api_url.'V1/Order/'.$client_id.'/'.$id;
        $curl = curl_init();
    
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_SSL_VERIFYHOST => 0,//for ssl
            CURLOPT_SSL_VERIFYPEER => 0,//for ssl
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer '.$token),
        ));
    
        $response = curl_exec($curl);
        $response_arr = json_decode($response, true);
        if (curl_errno($curl) || (!empty($response_arr) && isset($response_arr['status']) && $response_arr['status']==false)) {
            $error_msg = curl_error($curl);
            $report = ['status' => 0, 'message' => $error_msg];
        } else {
            $report = ['status' => 1, 'message' => $response_arr];
        }
        curl_close($curl);
    
        return $report; 
    
    }
    
    function get_acutrack_shipped_orders_store_wise($token,$client_id,$store_id,$po_no){
        $url=acutrack_api_url.'V1/Order/ListOrders/0/20/'.$client_id;
        $params=[
            'filter' => '{"ORSFIL":"5","STRFIL":"'.$store_id.'"}',
            'searchTerm' => $po_no,
        ];
        $params_query=http_build_query($params);
        $url.='?'.$params_query;
        $curl = curl_init();
    
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_SSL_VERIFYHOST => 0,//for ssl
            CURLOPT_SSL_VERIFYPEER => 0,//for ssl
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer '.$token),
        ));
    
        $response = curl_exec($curl);
        $response_arr = json_decode($response, true);
        if (curl_errno($curl) || (!empty($response_arr) && isset($response_arr['status']) && $response_arr['status']==false)) {
            $error_msg = curl_error($curl);
            $report = ['status' => 0, 'message' => $error_msg];
        } else {
            $report = ['status' => 1, 'message' => $response_arr];
        }
        curl_close($curl);
    
        return $report; 
    
    }
    
    function get_acutrack_client_gateways($token,$client_id=16,$in_active=0)
    {
    
        $url=acutrack_api_url.'Account/ClientGateways/'.$client_id;
        if($in_active==1){
            $url.='?filter={"CGASF":"CGINACTV"}';
        }
        $curl = curl_init();
    
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_SSL_VERIFYHOST => 0,//for ssl
            CURLOPT_SSL_VERIFYPEER => 0,//for ssl
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer '.$token),
        ));
    
        $response = curl_exec($curl);
        $response_arr = json_decode($response, true);
        if (curl_errno($curl) || (!empty($response_arr) && isset($response_arr['status']) && $response_arr['status']==false)) {
            $error_msg = curl_error($curl);
            $report = ['status' => 0, 'message' => $error_msg];
        } else {
            $report = ['status' => 1, 'message' => $response_arr];
        }
        curl_close($curl);
    
        return $report;
    }
    
    function get_acutrack_client_gateways_config($token,$client_gateway_id)
    {
    
    
        $curl = curl_init();
    
        curl_setopt_array($curl, array(
            CURLOPT_URL => acutrack_api_url.'Account/ConfigureClientGateway?clientgatewayid='.$client_gateway_id,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_SSL_VERIFYHOST => 0,//for ssl
            CURLOPT_SSL_VERIFYPEER => 0,//for ssl
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer '.$token),
        ));
    
        $response = curl_exec($curl);
        $response_arr = json_decode($response, true);
        if (curl_errno($curl) || (!empty($response_arr) && isset($response_arr['status']) && $response_arr['status']==false)) {
            $error_msg = curl_error($curl);
            $report = ['status' => 0, 'message' => $error_msg];
        } else {
            $report = ['status' => 1, 'message' => $response_arr];
        }
        curl_close($curl);
    
        return $report;
    }
    
    function api_token()
    {
        return $this->get_acutrack_auth_token();
    // 	$token = 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ1bmlxdWVfbmFtZSI6InJhbmd1cmFqQGFjdXRyYWNrLmNvbSIsInJvbGUiOiJJbnRlZ3JhdGlvbiIsIkNvbXBhbnkiOiJBY3V0cmFjayBJbmMiLCJUb2tlblR5cGUiOiJMb2dpbiIsIlVzZXJJZCI6Ijk0IiwiQ29tcGFueVR5cGUiOiJQYXJ0bmVyIiwiSXNQb3J0YWwiOiJUcnVlIiwibmJmIjoxNjY4NTQ4Njc3LCJleHAiOjE2Njg1NTIyNzcsImlhdCI6MTY2ODU0ODY3N30.T85KQhvouOndl-VoWiMxAafnWFzN8zGdDQ0H1_dZvto';
    // 	return ['status' => 1, 'token' => $token];
    }
}