<?php

require_once __DIR__.'/../vendor/autoload.php';

use app\controllers\admin\AdminController;
use app\controllers\AuthController;
use app\controllers\SiteController;
use app\core\Application;
use Josantonius\Session\Facades\Session;
$dotenv = Dotenv\Dotenv::createImmutable(dirname(__DIR__));
$dotenv->load();
require_once __DIR__.'/../config/constant.php';
require_once __DIR__.'/../config/config.php';

$app= new Application(dirname(__DIR__));
Session::start();
// DB::$user = 'root';
// DB::$password = '';
// DB::$dbName = 'zone_trigger'; 

// $data=DB::query("SELECT * FROM 	wb_monitor_user");

// echo '<pre>';
// print_r($data);
// die;

// $app->router->get('/','home');
// $app->router->get('/contact','contact');

$app->router->get('/',[SiteController::class,'home']);
$app->router->get('/contact',[SiteController::class,'contact']);
$app->router->post('/contact',[SiteController::class,'handleContact']);

$app->router->get('/login',[AuthController::class,'login']);
$app->router->get('/login/logout',[AuthController::class,'logout']);

$app->router->post('/login',[AuthController::class,'login']);
$app->router->get('/register',[AuthController::class,'register']);
$app->router->post('/register',[AuthController::class,'register']);
$app->router->post('/admin',[AuthController::class,'register']);

//admin
$app->router->get('/admin/dashboard',[AdminController::class,'index']);
$app->router->get('/admin/authorize',[AdminController::class,'authorize']);
$app->router->get('/ajax_control',[SiteController::class,'get_ajax_control']);
$app->router->post('/ajax_control',[SiteController::class,'post_ajax_control']);
$app->router->get('/admin/error_page',[AdminController::class,'error_page']);
$app->run(); 